module EventNewsModel
  module Cache
    require 'active_support/concern'
    extend ActiveSupport::Concern
    included do
      before_save :do_before_save
    end
    def do_before_save
      if self.class == SubPart
        ::EventNewsCache.where(parent_id:self.id).destroy
      elsif self.class == ::EventNews || (self.class == Page && self.module == "event_news")
        if self.class == ::EventNews
          tmp_tag_ids = (Array(self.tag_ids) + Array(self.org_tag_ids)).uniq
          Thread.new do
            ::EventNewsCache.where(:uid.in => ::EventNewsFeed.where(:tag_ids.in => tmp_tag_ids.collect{|v| v.to_s}).pluck(:uid)).each do |cache|
              cache.regenerate
            end
          end
        end
        ::EventNewsCache.all.destroy
      end
    end
  end
end